import { i18n } from '@/i18n'
import { percentageDiff } from '@/utils'

import { numberOfGamesSinceStart, operations, result } from './game-state'
import { showToast } from './toast-manager'

function getSharingText(): string {
  // × ÷ + -
  const emojis: string[] = []
  for (const op of operations) {
    switch (op.operator) {
      case '+':
        emojis.push('+')
        break
      case '-':
        emojis.push('-')
        break
      case '*':
        emojis.push('×')
        break
      case '/':
        emojis.push('÷')
        break
    }
  }
  const endResult = operations[operations.length - 1].result?.value ?? 0
  return `N0mbers #${numberOfGamesSinceStart()}
===========
${emojis.join(' ')} = ${endResult}
Score: ${100 - percentageDiff(result.value, endResult) * 100}%
===========
https://n0mbers.scambier.xyz`
}

export function toClipboard(): void {
  navigator.clipboard.writeText(getSharingText())
  showToast(i18n.global.t('copiedInClipboard'), 3000)
}
